/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_OperatorGraduateOp_h__
#define __operator_OperatorGraduateOp_h__

namespace fe
{

/**************************************************************************//**
    @brief Draw panels of lines behind an object

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT RulerOp:
	public OperatorSurfaceCommon,
	public Initialize<RulerOp>
{
	public:
				RulerOp(void):
					m_pickedA(FALSE),
					m_pickedB(FALSE)										{}

virtual			~RulerOp(void)												{}

		void	initialize(void);

				//* As HandlerI
virtual void	handle(Record& a_rSignal);

	private:

	class Edge
	{
		public:
								Edge(void):
									m_facing(0)								{}

			I32					m_facing;
	};

		sp<SurfaceAccessibleI>	m_spInputAccessible;
		sp<SurfaceI>			m_spInput;

		sp<DrawMode>			m_spOverlay;
		sp<DrawMode>			m_spBrush;
		sp<DrawMode>			m_spHaze;

		WindowEvent				m_event;

		BWORD					m_pickedA;
		BWORD					m_pickedB;
		SpatialVector			m_pointA;
		SpatialVector			m_pointB;
		SpatialVector			m_normA;
		SpatialVector			m_normB;
		I32						m_triIndexA;
		I32						m_triIndexB;
		SpatialBary				m_barycenterA;
		SpatialBary				m_barycenterB;
};

} // namespace

#endif /* __operator_OperatorGraduateOp_h__ */
